package de.micka.lebenshilfe;

import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

public class ListeListAdapter extends BaseAdapter
{
	private ArrayList<Liste> mData = new ArrayList<Liste>();
	private final LayoutInflater mLayoutInflater;
	public ListeListAdapter(Context pContext, ArrayList<Liste> pData)
	{
	                mData = pData;
	                
	                mLayoutInflater = (LayoutInflater) pContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	}
	//Gibt uns die Anzahl der Elemente in der ArrayList zurck
	public int getCount() 
	{
		return mData.size();
	}
	//Gibt uns das Item an der gewnschten Stelle zurck
	public Object getItem(int pPosition) 
	{
		return mData.get(pPosition);
	}
	//getItemId() gibt normalerweise die Reihen ID zurck, welche mit dem Element an der Position in der ArrayList in Verbindung gebracht wird. Fr unseren Zweck aber uninteressant.
	public long getItemId(int pPosition) 
	{
		Liste tab = mData.get(pPosition);
		return tab.id;
	}
	public void changeData(ArrayList<Liste> pData)
	{
        mData = pData;
        this.notifyDataSetChanged();
	}
	//
	public View getView(int pPosition, View convertView, ViewGroup parent) 
	{
		if (convertView == null) 
		{
            convertView = mLayoutInflater.inflate(R.layout.listenanzeigenlayout, null);
        }
		TextView holder = (TextView) convertView.findViewById(R.id.btn_tabelle);
		holder.setText(((Liste)getItem(pPosition)).listenname);
		
        return convertView;
	}
	
}

/*public class ListeListAdapter extends ArrayAdapter<Liste>
{
	private int resourceId;
	public ListeListAdapter(Context pContext,int resourceId, List<Liste> pData)
	{
		super(pContext, resourceId, pData);
		this.resourceId = resourceId;
	}
	public ListeListAdapter(Context pContext, int resourceId, int textViewResourceId, List<Liste> pData)
	{
		super(pContext, resourceId, textViewResourceId, pData);
		this.resourceId = resourceId;
	}
	public View getView(int pPosition, View convertView, ViewGroup parent) 
	{
		Liste liste = getItem(pPosition);
		LinearLayout layout = null;
		if (convertView == null) 
		{
            layout = new LinearLayout(getContext());
			LayoutInflater inflater = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        }else
        {
        	layout = (LinearLayout) convertView;
        }
		
		//((TextView) convertView.findViewById(R.id.btn_tabelle)).setText(((Liste)getItem(pPosition)).listenname);
		//((TextView) convertView.findViewById(R.id.btn_tabelle)).setId(((Liste)getItem(pPosition)).id);
		TextView anzeige = (TextView) convertView.findViewById(R.id.btn_tabelle);
		anzeige.setText(liste.listenname);
		//anzeige.setId(mData.get(pPosition).id);
			
        return convertView;
	}
	
}*/
