package de.micka.lebenshilfe;


import java.util.ArrayList;
import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.Toast;

public class ListenUebersicht extends ListActivity implements Constants 
{
	private HaushaltsbuchDataManager dataManager;
	private Liste liste;
	public static String LISTENID ="listenId";
	public static String LISTENNAME ="listenname";
	public static String LISTENTYPEXTRA = "listentyp";
	public static String NEUELISTE = "neueListe";
	public static final String ID = "id";
	private String listenname;
	private long listenid;
	private String listentyp;
	private View header = null;
	private ListView listView = null;
	private ListeListAdapter mAdapter;
    private ArrayList<Liste> mData = new ArrayList<Liste>();
    private MenuInflater inflater;
    private AdapterContextMenuInfo info;
    private EditText newTable = null;
    private boolean neueListe = false;
	
	/** Called when the activity is first created. */
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        initiateData();		//Array-List fr Listview fllen
    	mAdapter = new ListeListAdapter(this, mData);
    	header = getLayoutInflater().inflate(R.layout.uebersichttitellayout, null);
    	listView = getListView();
    	registerForContextMenu(listView);
		listView.addHeaderView(header);
    	this.setListAdapter(mAdapter);
    }
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            finish();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }
    private void listeLoeschen(long id)
    {
    	dataManager = new HaushaltsbuchDataManager(this);
    	SQLiteDatabase db = dataManager.getWritableDatabase();
    	db.execSQL("DELETE FROM " + LISTEN_TABLE_NAME + " WHERE "+ Constants._ID + " = '" + id + "';");
    	db.execSQL("DELETE FROM" + EINTRAEGE_TABLE_NAME + " WHERE " + Constants.LISTID + " = '" + id + "';");
    	db.close();
    	dataManager.close();
    	final Intent intent = new Intent(this, ListenUebersicht.class);
		finish();
		startActivity(intent);
    }
    public void listeUmbenennen(long tabid)
    {
    	dataManager = new HaushaltsbuchDataManager(this);
    	SQLiteDatabase db = dataManager.getReadableDatabase();
    	Cursor cursor = db.rawQuery("SELECT " + Constants.LISTENNAME +" FROM "+ LISTEN_TABLE_NAME + " WHERE _id = " + tabid , null);
   	 	cursor.moveToFirst();
   	 	listenname = cursor.getString(0);
   	 	cursor.close();
   	 	db.close();
   	 	dataManager.close();
   	 	final Intent intent = new Intent(this, ListeBearbeiten.class);
   	 	intent.putExtra(LISTENID, tabid);
   	 	intent.putExtra(LISTENNAME, listenname);
   	 	finish();
		startActivity(intent);
    }
    public void onCreateContextMenu(ContextMenu menu, View v,ContextMenuInfo menuInfo) 
    {
    	super.onCreateContextMenu(menu, v, menuInfo);
    	inflater = getMenuInflater();
    	inflater.inflate(R.menu.tabellecontext, menu);
    }
    public boolean onContextItemSelected(MenuItem item) 
    {
      info = (AdapterContextMenuInfo) item.getMenuInfo();
      switch (item.getItemId()) {
      case R.id.tabelle_context_bearbeiten:
    	  listeUmbenennen(info.id);
     	  //Log.v(tag, mData.get(info.position-1).tabellenname);
    	  return true;
      case R.id.tabelle_context_loeschen:
    	  listeLoeschen(info.id);
          return true;
      default:
        return super.onContextItemSelected(item);
      }
    }    
    private void initiateData()
    {
    	Log.i("Listenbersicht","initiate Data ");
        dataManager = new HaushaltsbuchDataManager(this);
  	  	try {
      	  SQLiteDatabase db = dataManager.getReadableDatabase();
      	  Cursor cursor = db.rawQuery("SELECT " 
      			  							+ _ID + ", " 
      			  							+ LISTENNAME 
      			  							+ " FROM "
      			  							+ LISTEN_TABLE_NAME 
      			  							+ " Order By listenname", null);
      	  startManagingCursor(cursor);
      	  	if(cursor.moveToFirst())
      	  	{
      	  		do
      	  		{
      	  			liste = null;
      	  			cursor.moveToFirst();
      	  			liste = new Liste(cursor.getInt(0),cursor.getString(1));
      	  			mData.add(liste);
      	  			cursor.moveToNext();
      	  		}while(cursor.isAfterLast() == false);
      	  	}
      	  	cursor.close();      	  
    	  	db.close();
    	  	dataManager.close();
        }finally
        {
        	dataManager.close();
        }
    }
    public void onClickTabelleAnzeigen(View view)
    {
    	TextView clicked = (TextView) view;
    	//Neue Activity
    	final Intent intent = new Intent(this, ListenAnsicht.class);
    	//zu bergebene Werte setzen
		listenname = clicked.getText().toString() ;
		try {
			SQLiteDatabase db = dataManager.getReadableDatabase();
	      	Cursor cursor = db.rawQuery("SELECT " + _ID + ", " + Constants.LISTENTYP + " FROM "+ LISTEN_TABLE_NAME + " WHERE "+ Constants.LISTENNAME+ " = '" + listenname +"'", null);
	      	startManagingCursor(cursor);
	      		if(cursor.moveToFirst())
	      	  	{
	      			listenid = cursor.getLong(0);
	      	  		listentyp = cursor.getString(1);
	      	  	}
	      	cursor.close();
	      	db.close();
	        } finally {
	        	dataManager.close();
	        }
		//Extras bergeben
		intent.putExtra(LISTENID, listenid);
		intent.putExtra(LISTENTYPEXTRA, listentyp);
		finish();
		startActivity(intent);
    }
    public void onClickTabelleHinzufuegen(View view)
    {
    	newTable = null;
    	newTable = (EditText) findViewById(R.id.edt_liste_name);
    	RadioGroup radioGroup = (RadioGroup) findViewById(R.id.radiogroup_tabellentyp);
    	int checkedRadioButton = radioGroup.getCheckedRadioButtonId();
    	//Fehlende Eingaben prfen
    	if(newTable.getText().toString().equals(""))//Listenname
    	{
    		Toast msg = Toast.makeText(ListenUebersicht.this, "Sie haben keinen Listennamen eingegeben", Toast.LENGTH_LONG);

    		msg.setGravity(Gravity.CENTER, msg.getXOffset() / 2, msg.getYOffset() / 2);

    		msg.show();
    	}else if(checkedRadioButton == -1)//Listentyp
    	{
    		Toast msg = Toast.makeText(ListenUebersicht.this, "Sie haben keinen Listentyp gewhlt", Toast.LENGTH_LONG);

    		msg.setGravity(Gravity.CENTER, msg.getXOffset() / 2, msg.getYOffset() / 2);

    		msg.show();
    	}else//wenn alle Eingaben vorhanden
    	{
    		final Intent intent = new Intent(this, EintragHinzufuegen.class);
    		listenname = newTable.getText().toString();
    		listentyp = "bla";
    		
    		switch (checkedRadioButton) 
    		{
    		case R.id.radioButtonTaschengeld : listentyp = "taschengeld";
    	         break;
    		case R.id.radioButtonWirtschaft : listentyp = "wirtschaftsgeld";
    			 break;
    		}
    		neueListe = true;
    		intent.putExtra(LISTENNAME, listenname);
    		intent.putExtra(LISTENTYPEXTRA, listentyp);
    		intent.putExtra(NEUELISTE, neueListe);
    		finish();
    		startActivity(intent);
    	}
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
    	getMenuInflater().inflate(R.menu.optionsmenu_listenuebersicht, menu);
    	return super.onCreateOptionsMenu(menu);
    }
    public boolean onOptionsItemSelected(MenuItem item)
    {//Was passiert wenn ein Options-Men Eintrag gewhlt wird
    	switch(item.getItemId())
    	{
    		case R.id.opt_beenden_listenuebersicht: 
    			System.exit(0);
    		default:
    			return super.onOptionsItemSelected(item);
    	}
    }
}